#define STRICT

#define _CRT_SECURE_NO_WARNINGS
#define WIN32_WINNT 0x0501

#include <windows.h>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <shlwapi.h>
#include <map>
#include <vector>
#include <list>
#include <algorithm>
#include "utility.h"
#include "config.h"

//𐔂}N
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))

#define FILL_ZERO(x)	::ZeroMemory(&x,sizeof(x))
#define ASSERT(x)	assert(x)


typedef int   (WINAPI *COMMON_ARCHIVER_HANDLER)(const HWND,LPCSTR,LPSTR,const DWORD);


//A[JCoDLLbvpNX̃x[X
class CArchiverDLL{
protected:
	//---------
	HINSTANCE	m_hInstDLL;			//DLLCX^X
	COMMON_ARCHIVER_HANDLER			m_lpArchiveHandler;	//Un???֐
	bool IsOK()const{return NULL!=m_hInstDLL;}		//A[JCoDLL[hĂ邩

public:
	CArchiverDLL():m_hInstDLL(NULL),m_lpArchiveHandler(NULL){}
	virtual ~CArchiverDLL(){FreeDLL();}
	int ArchiverHandler(const HWND hWnd,LPCSTR szCmdLine,LPSTR szOutput,const DWORD dwSize){
		return m_lpArchiveHandler(hWnd,szCmdLine,szOutput,dwSize);
	}
	void FreeDLL(){
		m_lpArchiveHandler=NULL;
		if(m_hInstDLL){
			FreeLibrary(m_hInstDLL);
			m_hInstDLL=NULL;
		}
	}
	bool LoadDLL(LPCTSTR lpDLLName,LPCTSTR lpEntryPoint){
		FreeDLL();

		if(NULL==(m_hInstDLL=LoadLibrary(lpDLLName))){
			return false;
		}

		m_lpArchiveHandler=(COMMON_ARCHIVER_HANDLER)GetProcAddress(m_hInstDLL,lpEntryPoint);
		if(NULL==m_lpArchiveHandler){
			FreeDLL();
			return false;
		}
		return true;
	}
};

bool WriteFileList(LPCTSTR fname,const std::vector<std::string> &files,int start,int end)
{
	FILE *fp=fopen(fname,"w");
	if(!fp)return false;

	for(int i=start;i<end;i++){
		fprintf(fp,"\"%s\"\n",files[i].c_str());
	}

	fclose(fp);

	return true;
}

int main(int argc,char **argv)
{
	CConfig conf;

	char confname[_MAX_PATH];
	GetModuleFileName(GetModuleHandle(NULL),confname,COUNTOF(confname));
	PathRemoveFileSpec(confname);
	PathAppend(confname,"archiver.ini");

	if(0!=conf.Load(confname)){
		printf("failed to load %s\n",confname);
		return -1;
	}

	CArchiverDLL archiver;
	if(!archiver.LoadDLL(conf.getStr("dll"),conf.getStr("func"))){
		printf("failed to load %s ,func=%s\n",conf.getStr("dll"),conf.getStr("func"));
		return -2;
	}

	char szOutput[1024];
	if(argc>=3){
		if(argc>=4 && 0==_tcscmp(argv[1],"/slave")){
			std::string cmd=conf.getStr("cmd.compress");
			cmd+=" ";
			cmd+=argv[2];	//archive name
			cmd+=" @";
			cmd+=argv[3];	//intput name
			return archiver.ArchiverHandler(NULL,cmd.c_str(),szOutput,COUNTOF(szOutput));
		}else{
			//master mode
			std::string arcname=argv[1];
			::DeleteFile(arcname.c_str());

			//enumerate files
			std::vector<std::string> files;
			for(int i=2;i<argc;i++){
				char szFull[_MAX_PATH];
				_fullpath(szFull,argv[i],sizeof(szFull));
				UtilRecursiveEnumFile(szFull,files);
			}
			if(files.empty()){
				printf("no files to compress\n");
				return -4;
			}
			//getting number of system CPU
			SYSTEM_INFO sysInfo;
			::GetNativeSystemInfo(&sysInfo);
			int numProc=sysInfo.dwNumberOfProcessors;

			//multi-process compression
			std::vector<std::string> tempfiles;
			std::vector<HANDLE> processArray;
			std::vector<std::string> arcfiles;
			std::vector<std::vector<char> > cmdargs(numProc);
			for(int i=0;i<numProc;i++){
				std::string fname;
				UtilGetTemporaryFileName(fname,"mtc");
				tempfiles.push_back(fname);

				WriteFileList(fname.c_str(),files,files.size()*i/numProc,files.size()*(i+1)/numProc);

				char szfile[512];
				sprintf(szfile,"tmp%d.%s",i,conf.getStr("arcext"));
				arcfiles.push_back(szfile);

				std::string cmd=argv[0];
				cmd+=" /slave ";
				cmd+=szfile;
				cmd+=" ";
				cmd+=fname;
				cmdargs[i].resize(cmd.length()+1);
				strcpy(&cmdargs[i][0],cmd.c_str());
				printf("making %s\n",szfile);

				STARTUPINFO si={sizeof(STARTUPINFO)};
				PROCESS_INFORMATION pi;

				::CreateProcess(NULL,&cmdargs[i][0],NULL,NULL,FALSE,0,NULL,NULL,&si,&pi);
				::CloseHandle(pi.hThread);
				processArray.push_back(pi.hProcess);
			}
			//waiting for process to end
			::WaitForMultipleObjects(numProc,&processArray[0],TRUE,INFINITE);

			//process done, checking exit code, deleting temporary files
			bool bOK=true;
			for(int i=0;i<numProc;i++){
				DWORD dwCode;
				if(!::GetExitCodeProcess(processArray[i],&dwCode) || 0!=dwCode)bOK=false;
				::CloseHandle(processArray[i]);
				::DeleteFile(tempfiles[i].c_str());
			}

			if(!bOK){
				printf("Something wrong.\n");
				for(int i=0;i<numProc;i++){
					::DeleteFile(arcfiles[i].c_str());
				}
				return -3;
			}

			//concat
			std::string cmd=conf.getStr("cmd.concat");
			cmd+=" ";
			cmd+=arcname;
			for(size_t i=0;i<arcfiles.size();i++){
				cmd+=" ";
				cmd+=arcfiles[i];
			}
			if(0==archiver.ArchiverHandler(NULL,cmd.c_str(),szOutput,COUNTOF(szOutput))){
				printf("Process:OK\n");
			}else{
				printf("Process:Failed\n");
			}
			for(int i=0;i<numProc;i++){
				::DeleteFile(arcfiles[i].c_str());
			}
		}
	}

	return 0;
}
